package grlogs

import (
	"bytes"
	"encoding/json"
)

type ConsoleLogConfig struct {
	Level int `json:"level"`
}

func (c *ConsoleLogConfig) String() string {
	b, _ := json.Marshal(c)
	return bytes.NewBuffer(b).String()
}

type FileLogConfig struct {
	Filename string `json:"filename"`
	Level    int    `json:"level"`
	Maxlines int    `json:"maxlines"`
	Daily    bool   `json:"daily"`
	Maxdays  int    `json:"maxdays"`
	Color    bool   `json:"color"`
	Rotate   bool   `json:"rotate"`
}

func (c *FileLogConfig) String() string {
	b, _ := json.Marshal(c)
	return bytes.NewBuffer(b).String()
}

type ConnLogConfig struct {
	ReconnectOnMsg bool   `json:"reconnect_on_msg"`
	Reconnect      bool   `json:"reconnect"`
	Net            string `json:"net"`
	Addr           string `json:"addr"`
	Level          int    `json:"level"`
}

func (c *ConnLogConfig) String() string {
	b, _ := json.Marshal(c)
	return bytes.NewBuffer(b).String()
}

type EsConfig struct {
	Dsn   string `json:"dsn"`
	Level int    `json:"level"`
}

func (c *EsConfig) String() string {
	b, _ := json.Marshal(c)
	return bytes.NewBuffer(b).String()
}
